#!/usr/bin/perl
#-----------------------------------------------------------------------------
# Haupt-Skript des II99-Forums von Thiemo Mttig, thiemo@maettig.com
# Zuletzt ueberarbeitet am 2003-03-07
#-----------------------------------------------------------------------------

# Das Konfigurations-Skript wird hier unbedingt benoetigt!
require 'ii99forum_cfg.cgi';

#-----------------------------------------------------------------------------

&initialisieren;
if ($FORM{'aktion'} eq 'neu') { &neuen_eintrag_holen; }
elsif ($FORM{'betreff'} || $FORM{'text'}) { &neuen_eintrag_eintragen; }
elsif ($FORM{'id'} > 0) { &zeige_eintrag; }
else { &zeige_thread; }
die;

#-----------------------------------------------------------------------------

sub zeige_thread
{
#TOPIC_SORT_PROBLEM
  if ($FORM{'modus'} eq 'topic') { $FORM{'sort'} = ''; }

  if ($FORM{'absender'} || $FORM{'permanent'})
  {
    &getcookie;
    # Nach dem Absenden eines neuen Eintrages ist das Feld "Absender" gesetzt
    if ($FORM{'absender'})
    {
      $COOKIE[0] = $FORM{'absender'}; $COOKIE[1] = $FORM{'email'}; $COOKIE[2] = '';
    }
    # Auf Wunsch ist beim Aendern der Ansicht das Feld "permanent" angekreuzt
    if ($FORM{'permanent'})
    {
      $COOKIE[3] = $FORM{'modus'}; $COOKIE[4] = $FORM{'sort'}; $COOKIE[5] = $FORM{'zeilen'};
    }
    $cookievar = "$COOKIE[0]%09$COOKIE[1]%09$COOKIE[2]%09$COOKIE[3]%09$COOKIE[4]%09$COOKIE[5]";
    # Kritische Zeichen im Cookieinhalt kodieren
    $cookievar =~ s/([,;\s])/sprintf("%%%X",ord($1))/eg;
    print "Set-Cookie: ii99\=$cookievar; expires\=Fri, 14-Jan-2038 00:00:00 GMT;\n";
  # Beim Start des Forums ohne Einstellungen diese aus dem Cookie holen
  }
  elsif (! $FORM{'modus'} && ! $FORM{'sort'} && ! $FORM{'zeilen'})
  {
    &getcookie;
    $FORM{'modus'} = $COOKIE[3]; $FORM{'sort'} = $COOKIE[4]; $FORM{'zeilen'} = $COOKIE[5];
  }
  
  if ($FORM{'modus'}) { $sort = "&modus=$FORM{'modus'}"; }
  if ($FORM{'sort'}) { $sort .= "&sort=$FORM{'sort'}"; }
  if ($FORM{'zeilen'}) { $sort .= "&zeilen=$FORM{'zeilen'}"; }
  elsif ($FORM{'zeilen'} < 10) { $FORM{'zeilen'} = $zeilen; }
  print $html_kopf;
  print $html_begruessung;
  print "<p align=center>[ <a href=\"$0?$sort\">Anzeige aktualisieren</a> | ";
  if ($FORM{'seite'} > 1) { $sort .= "&seite=$FORM{'seite'}"; }
  print "<a href=\"$0?aktion=neu$sort\">Neuen Eintrag schreiben</a> ]</p>";

  &alles_einlesen;
  if ($anz < 1) { print '<p>Keine Eintr&auml;ge vorhanden.</p>'; print $html_fuss; die; }

  #Sortieren##################################################################

  # Die Pointer fuer die nach Datum sortierte Darstellung vorbereiten.
  if ($FORM{'sort'} eq "d")
  {
    for ($zaehler = $anz; $zaehler > 1; $zaehler--) { $pointer[$zaehler] = $zaehler-1; }
    $zaehler=$anz;

  # Sortierung nach Absender, innerhalb des Absenders das neueste zuerst.
  }
  elsif ($FORM{'sort'} eq "a")
  {
    $zaehler=1;
    for ($i = 2; $i <= $anz; $i++)
    {
      if ("\L$absender[$i]" lt "\L$absender[$zaehler]")
      {
        $pointer[$i] = $zaehler; $zaehler = $i;
      }
      else
      {
        $n=$zaehler;
        while ($n > 0)
        {
          if (($pointer[$n]<1) || ("\L$absender[$i]" le "\L$absender[$pointer[$n]]"))
          {
            $pointer[$i]=$pointer[$n]; $pointer[$n]=$i; $n=0;
          }
          else
          {
            $n = $pointer[$n];
          }
        }
      }
    }

  # Sortierung nach Betreff, innerhalb des Betreffs das neueste zuerst.
  }
  elsif ($FORM{'sort'} eq "b")
  {
    $zaehler=1;
    for ($i = 2; $i <= $anz; $i++)
    {
      if ("\L$betreff[$i]" lt "\L$betreff[$zaehler]")
      {
        $pointer[$i] = $zaehler; $zaehler = $i;
      }
      else
      {
        $n=$zaehler;
        while ($n > 0)
        {
          if (($pointer[$n] < 1) || ("\L$betreff[$i]" le "\L$betreff[$pointer[$n]]"))
          {
            $pointer[$i] = $pointer[$n]; $pointer[$n] = $i; $n = 0;
          }
          else
          {
            $n = $pointer[$n];
          }
        }
      }
    }

  # Die Pointer fuer die Darstellung des Threads sortieren.
  }
  else
  {
    $zaehler_alt = 1;
    for ($zaehler = 2; $zaehler <= $anz; $zaehler++)
    {
      if ($re[$zaehler] > 0 && &suche_arraynum($re[$zaehler], $zaehler - 1) == 0)
      {
        $pointer[$zaehler] = $pointer[$arraynum];
        $pointer[$arraynum] = $zaehler;
        $tiefe[$zaehler] = $tiefe[$arraynum] + 1;
      }
      else
      {
        $pointer[$zaehler] = $zaehler_alt; $zaehler_alt = $zaehler;
      }
    }
    # Der Startwert fuer die Ausgabe steht jetzt in $zaehler_alt
    $zaehler = $zaehler_alt;
  }

  #Eintraege sortiert ausgeben################################################

  print "<table width=\"$tablewidth\" border=0 cellspacing=0 cellpadding=1>\n";
  if ($FORM{'modus'} ne "komplett")
  {
    if ($FORM{'modus'} eq "topic")
    {
      print "<tr bgcolor=\"$bgfarbe\"><th align=left>Betreff</th><th align=left>Absender</th><th align=left>Antworten</th><th align=right>Letzte\&nbsp\;Antwort</th></tr>\n";
#TOPIC_SORT_PROBLEM
#      # Im Topic-Modus alle Eintraege ueberspringen, die keine Topics sind
#      while ($re[$zaehler] > 0) { $zaehler = $pointer[$zaehler]; }
    }
    else
    {
      print "<tr bgcolor=\"$bgfarbe\"><th align=left>Betreff</th><th align=left>Absender</th><th align=right>Datum</th></tr>\n";
    }
    $farbe=" ";
  }
  $seite=1;
  $aday=int((time/3600+1)/24); # Aktueller Tag fuer die Anzeige von "heute"

  # Alles schreiben, solange der Pointer nicht ins Leere zeigt.
  while ($zaehler > 0)
  {

    # Tatsaechliche Ausgabe nur, wenn die gewuenschte Seite erreicht ist.
    if ($FORM{'seite'} < 1 || $FORM{'seite'} == $seite)
    {

      # Farbe jedesmal wechseln, wenn ein Eintrag der Tiefe 0 erscheint.
      if ($tiefe[$zaehler] < 1)
      {
        if ($farbe eq '') { $farbe = " bgcolor=\"$bgfarbe\""; } else { $farbe = ''; }
      }

      # Die meisten der Sonderzeichen unabhaengig vom Modus wiederherstellen.
      $absender[$zaehler] =~ s/%a/&amp;/g; $absender[$zaehler] =~ s/%p/%/g;
      $absender[$zaehler] =~ s/</&lt;/g; $betreff[$zaehler] =~ s/</&lt;/go;
      $betreff[$zaehler] =~ s/%a/&amp;/g; $betreff[$zaehler] =~ s/%p/%/g;

      # Der Komplett-Modus zeigt "[Name] Betreff: Text (Datum)"
      if ($FORM{'modus'} eq 'komplett')
      {
        print "<tr$farbe><td><p style=\"text-indent:-35px;margin-left:";
        print $tiefe[$zaehler] * 20 + 35;
        print "px\">\n<b><a href=\"$0?aktion=neu&id=$id[$zaehler]$sort\">[";
        print $absender[$zaehler] ? $absender[$zaehler] : 'Anonymous';
        print ']</a>';
        if (time - $datum[$zaehler] < $new_hours) { print $new_text; }
        if ($betreff[$zaehler])
        {
	  print "\n$betreff[$zaehler]";
	  if ($text[$zaehler]) { print ':'; }
	}
	$text[$zaehler] =~ s/%a/&/g;
        # Nur Undzeichen maskieren, die Teil eines HTML-Codes sind
        $text[$zaehler] =~ s!&(?=[#\w]+;)!&amp;!g;
        $text[$zaehler] =~ s/</&lt;/g; $text[$zaehler] =~ s/>/&gt;/g;
        $text[$zaehler] =~ s/(\s*%n)+/<br>/g;
        $text[$zaehler] =~ s/%p/%/g;
        # Ueberlange Textteile aus identischen Zeichen auf maximal 10 kuerzen
        $text[$zaehler] =~ s/(.)(\1{10})\1*/$2/g;
        if ($allow_html)
        {
          # HTML-Formatierungen im Komplett-Modus nur eingeschraenkt anzeigen
          $text[$zaehler] =~ s/\[\/?img\]//gi;
          $text[$zaehler] =~ s/\[(i|b)\](.+?)\[\/\1\]/<i>$2<\/i>/gis;
          $text[$zaehler] =~ s/\[(tt|pre)\](.+?)\[\/\1\]/<tt>$2<\/tt>/gis;
        }
	# Links anklickbar machen, generell in neuem Fenster oeffnen
        $text[$zaehler] =~ s/(http:\/\/|(www\.))([\w-]+\.\w[\w%\.\-~_\/#?=&+,;]*[\w\/])/<a href="http:\/\/$2$3" target="_blank">$1$3<\/a>/gi;
        print "</b>\n$text[$zaehler]\n<small>(" . &datum($datum[$zaehler]) . ")</small>\n</p></td></tr>\n\n";

      # Der Topic-Modus zeigt nur die Haupteintraege auf der untersten Ebene
      }
      elsif ($FORM{'modus'} eq 'topic')
      {
        print "<tr$farbe><td><a href=\"$0?id=$id[$zaehler]$sort\">";
        if (! $betreff[$zaehler])
        {
	  $betreff[$zaehler] = $text[$zaehler];
          $betreff[$zaehler] =~ s/%n/ /g;
          $betreff[$zaehler] =~ s/%a/&amp;/g; $betreff[$zaehler] =~ s/%p/%/g;
        }
	$betreff[$zaehler] =~ s/^(.{1,$betreffmax})( |$).*/$1/;
        print $betreff[$zaehler], '</a></td><td>';
        print $absender[$zaehler] ? $absender[$zaehler] : '-';
        $replies = 0; $juengster = $datum[$zaehler];
        while ($re[$pointer[$zaehler]] > 0)
        {
          $zaehler = $pointer[$zaehler]; $replies++;
          if ($datum[$zaehler] > $juengster) { $juengster = $datum[$zaehler]; }
        }
        print "</td><td><a href=\"$0?id=$id[$zaehler]$sort\">$replies</a>";
        if (time - $juengster < $new_hours) { print $new_text; }
        print '</td><td align=right>', &datum($juengster), "</td></tr>\n";

      # Der normale Modus zeigt "Betreff, Absender, Datum"
      }
      else
      {
        print "<tr$farbe><td>";
        for ($i = 1; $i <= $tiefe[$zaehler]; $i++) { print '&nbsp;&nbsp;'; }
        print "<a href=\"$0?id=$id[$zaehler]$sort\">";
        if (! $betreff[$zaehler])
        {	
	  $betreff[$zaehler] = $text[$zaehler];
          $betreff[$zaehler] =~ s/^(.{1,$betreffmax})( |$).*/$1/;
          $betreff[$zaehler] =~ s/%n/ /g;
          $betreff[$zaehler] =~ s/%a/&amp;/g; $betreff[$zaehler] =~ s/%p/%/g;
        }
	print $betreff[$zaehler], '</a>';
        if (time - $datum[$zaehler] < $new_hours) { print $new_text; }
        print "</td>\n<td>";
        $absender[$zaehler] eq '' ? print "-" : print substr($absender[$zaehler],0,$absendermax);
        print "</td><td align=right>";
        print &datum($datum[$zaehler]),"</td></tr>\n\n";
      }
    }

    # Ueberspringen der Antworten im Topicmodus, sonst wird falsch gezaehlt
    if ($FORM{'modus'} eq "topic")
    {
      while ($re[$pointer[$zaehler]] > 0) { $zaehler = $pointer[$zaehler]; }
    }
    # Naechsten Text waehlen, Zeilenzaehler erhoehen und Seitennummer pruefen
    $zaehler=$pointer[$zaehler];
    $zeilencount++;
    if ($zeilencount >= $FORM{'zeilen'} && $tiefe[$zaehler] < 1)
    {
      if ($seite >= $FORM{'seite'}) { last; }
      $seite++; $zeilencount=0;
    }
  }

  #Die Optionen anzeigen######################################################

  print "</table>\n";
  if ($zaehler > 0 || $FORM{'seite'} > 1)
  {
    print "<p align=center>[ ";
    $sort =~ s/\&seite=\d*//;
    if ($FORM{'seite'} > 1)
    {
      print "<a href=\"$0?seite=" . ($seite-1) . "$sort\">&lt;&lt;</a>";
    }
    else
    {
      print "&lt;&lt;";
    }
    print " | Seite $seite | ";
    if ($zaehler > 0)
    {
      print "<a href=\"$0?seite=" . ($seite+1) . "$sort\">&gt;&gt;</a>";
    }
    else
    {
      print "&gt;&gt;";
    }
    print " ]</p>\n";
  }
  print "<form action=\"$0\" method=\"get\"><p align=\"center\"><font size=\"2\">";
  if ($allow_modes)
  {
    print 'Anzeige: <select name="modus" size=1><option value=""';
    if ($FORM{'modus'} eq '') { print ' selected'; }
    print '>Normal<option value="komplett"';
    if ($FORM{'modus'} eq 'komplett') { print ' selected'; }
    print '>Komplett<option value="topic"';
    if ($FORM{'modus'} eq 'topic') { print ' selected'; }
    print ">Topics</select>\n";
  }
#TOPIC_SORT_PROBLEM
  if ($FORM{'modus'} ne 'topic')
  {
    print 'Sortierung: <select name="sort" size=1><option value=""';
    if ($FORM{'sort'} eq '') { print ' selected'; }
    print '>Thread<option value="d"';
    if ($FORM{'sort'} eq "d") { print ' selected'; }
    print '>Datum<option value="a"';
    if ($FORM{'sort'} eq "a") { print ' selected'; }
    print '>Absender<option value="b"';
    if ($FORM{'sort'} eq "b") { print ' selected'; }
    print ">Betreff</select>\n";
  }
  print 'Anzahl: <select name="zeilen" size=1><option';
  if ($FORM{'zeilen'} == 10) { print ' selected'; }
  print '>10<option';
  if ($FORM{'zeilen'} == 25) { print ' selected'; }
  print '>25<option';
  if ($FORM{'zeilen'} == 50) { print ' selected'; }
  print '>50<option';
  if ($FORM{'zeilen'} == 100) { print ' selected'; }
  print '>100<option value="1000"';
  if ($FORM{'zeilen'} >= 1000) { print ' selected'; }
  print ">alle</select>\n";
  print "<input name=\"permanent\" type=\"checkbox\" value=\"1\">permanent\n";
  print "<input type=\"submit\" value=\"OK\"></font></p></form>";

  print $html_schlusswort; print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub zeige_eintrag
{
  &alles_einlesen;
  if (&suche_arraynum($FORM{'id'}) < 0) { zeige_thread; }
  print $html_kopf;

  if ($FORM{'modus'}) { $sort = "&modus=$FORM{'modus'}"; }
  if ($FORM{'sort'}) { $sort .= "&sort=$FORM{'sort'}"; }
  if ($FORM{'seite'} > 1) { $sort .= "&seite=$FORM{'seite'}"; }
  if ($FORM{'zeilen'}) { $sort .= "&zeilen=$FORM{'zeilen'}"; }

  # Anzeige im Topic-Modus mit allen Antworten direkt untereinander
  if ($FORM{'modus'} eq 'topic')
  {
    print "<p align=center>[ <a href=\"$0?$sort\">Zur&uuml;ck zur &Uuml;bersicht</a> ]</p>";
    # Zum obersten Eintrag des gewuenschten Threads springen
    while ($re[$arraynum] > 0) { &suche_arraynum($re[$arraynum], $arraynum - 1); }
    #$betreffvergleich = "Re: $betreff[$arraynum]";
    $idliste{$id[$arraynum]} = 1; $re[$arraynum] = $id[$arraynum];
    for (; $arraynum <= $anz; $arraynum++)
    {
      if (exists $idliste{$re[$arraynum]})
      {
        $betreff[$arraynum] =~ s/</&lt;/g; $betreff[$arraynum] =~ s/%a/&amp;/g;
        $betreff[$arraynum] =~ s/%p/%/g;
        $absender[$arraynum] =~ s/</&lt;/g; $absender[$arraynum] =~ s/%a/&amp;/g;
        $absender[$arraynum] =~ s/%p/%/g;

        print "<p><table width=\"$tablewidth\" border=1 cellspacing=0 cellpadding=3>\n";
        print "<tr><td width=1 align=right bgcolor=\"$bgfarbe\">Absender:</td><td width=\"99%\">";
        print $absender[$arraynum] ? $absender[$arraynum] : 'Anonymous';
        if ($FORM{'ip'})
        {
          print " ($ip[$arraynum], <a href=\"http://www.ripe.net/perl/whois?searchtext=$ip[$arraynum]\" target=\"_blank\">Ripe.net</a>, ";
          $ip[$arraynum] =~ s/(\d*)\.(\d*)\.(\d*)\.(\d*)/ip1=$1&ip2=$2&ip3=$3&ip4=$4/;
          print "<a href=\"http://www.amnesi.com/hostinfo/ipinfo.jhtml?$ip[$arraynum]\" target=\"_blank\">eAmnesia.com</a>)";
        }
        print "</td><td width=1 align=center bgcolor=\"$bgfarbe\">";
        # Antworten ist nicht mehr moeglich, wenn der Eintrag bereits veraltet ist
        if ($datum[$arraynum] > time - $old_days)
        {
          print "<a href=\"$0?aktion=neu&id=$id[$arraynum]$sort\">Antwort&nbsp;schreiben</a>";
        }
        else
        {
          print 'Antworten&nbsp;nicht&nbsp;m&ouml;glich';
        }
        print "</td></tr>\n";
        print "<tr><td align=right bgcolor=\"$bgfarbe\">Datum:</td><td colspan=2>" . &datum($datum[$arraynum],1) . "</td></tr>\n";
        if ($betreff[$arraynum] !~ m/^(Re: |$)/)
        {
          print "<tr><td align=right bgcolor=\"$bgfarbe\">Betreff:</td><td colspan=2>$betreff[$arraynum]</td></tr>\n";
        }
        if ($text[$arraynum])
        {
	  &parse_html($text[$arraynum]);
	  print "<tr><td colspan=3>$text[$arraynum]</td></tr>";
	}
        print "</table></p>\n";
        $idliste{$id[$arraynum]} = 1;
      }
    }
    print "<p align=center>[ <a href=\"$0?$sort\">Zur&uuml;ck zur &Uuml;bersicht</a> ]</p>";

  # Anzeige im Normalmodus
  }
  else
  {
    if (! $betreff[$arraynum])
    {
      $betreff[$arraynum] = $text[$arraynum];
      $betreff[$arraynum] =~ s/^(.{1,$betreffmax})( |$).*/$1/;
    }

    $betreff[$arraynum] =~ s/%a/&amp;/g; $betreff[$arraynum] =~ s/%n/ /g;
    $betreff[$arraynum] =~ s/</&lt;/g; $betreff[$arraynum] =~ s/%p/%/g;
    $absender[$arraynum] =~ s/</&lt;/g; $absender[$arraynum] =~ s/%a/&amp;/g;
    $absender[$arraynum] =~ s/%p/%/g;
    &parse_html($text[$arraynum]);

    print "<p><table width=\"$tablewidth\" border=1 cellspacing=0 cellpadding=3>\n";
    print "<tr><td align=right bgcolor=\"$bgfarbe\">Betreff:</td><td width=\"99%\">$betreff[$arraynum]</td></tr>\n";
    print "<tr><td align=right bgcolor=\"$bgfarbe\">Absender:</td><td>";
    print $absender[$arraynum] ? $absender[$arraynum] : 'Anonymous';

    if ($FORM{'ip'})
    {
      print " ($ip[$arraynum], <a href=\"http://www.ripe.net/perl/whois?searchtext=$ip[$arraynum]\" target=\"_blank\">Ripe.net</a>, ";
      $ip[$arraynum] =~ s/(\d*)\.(\d*)\.(\d*)\.(\d*)/ip1=$1&ip2=$2&ip3=$3&ip4=$4/;
      print "<a href=\"http://www.amnesi.com/hostinfo/ipinfo.jhtml?$ip[$arraynum]\" target=\"_blank\">eAmnesia.com</a>)";
    }

    print "</td></tr>\n";
    print "<tr><td align=right bgcolor=\"$bgfarbe\">Datum:</td><td>" . &datum($datum[$arraynum],1) . "</td></tr>\n";

    if ($re[$arraynum] > 0)
    {
      print "<tr><td align=right bgcolor=\"$bgfarbe\">Antwort&nbsp;auf:</td><td>";
      print "<a href=\"$0?id=$re[$arraynum]$sort\">$re[$arraynum]</a></td></tr>\n";
    }
    print '<tr><td colspan=2>';
    print $text[$arraynum] ? $text[$arraynum] : $betreff[$arraynum];
    print "</td></tr></table>\n\n";

#BETATEST#BETATEST#BETATEST#BETATEST#BETATEST
    if ($FORM{'beta'})
    {
      print "<p><table align=center border=0 cellspacing=0 cellpadding=0><tr><td>";
      print "<ul><li><a href=\"$0?id=$re[$arraynum]$sort\">Ursprungseintrag</a><br>\n";
      print '<ul>';
      for ($zaehler = $arraynum + 1; $zaehler <= $anz; $zaehler++)
      {
        if ($re[$zaehler] == $re[$arraynum])
        {
          print "<li><a href=\"$0?id=$id[$zaehler]$sort\">J&uuml;ngerer Eintrag</a><br>\n";
          last;
        }
      }
      print "<li>Dieser Eintrag<br>\n";
      print '<ul>';
      for ($zaehler = $anz; $zaehler > $arraynum; $zaehler--)
      {
        if ($re[$zaehler] == $FORM{'id'})
        {
          print "<li><a href=\"$0?id=$id[$zaehler]$sort\">Antwort</a> von ";
          print $absender[$zaehler] ? $absender[$zaehler] : 'Anonymous';
          print "<br>\n";
        }
      }
      print '</ul>';
      for ($zaehler = $arraynum - 1; $zaehler > 0; $zaehler--)
      {
        if ($re[$zaehler] == $re[$arraynum])
        {
          print "<li><a href=\"$0?id=$id[$zaehler]$sort\">&Auml;lterer Eintrag</a><br>\n";
          last;
        }
      }
      print '</ul>';
      print "</td></tr></table>\n\n";
    }

    # Vorgaenger und Nachfolger zum Blaettern ermitteln.
    for ($zaehler = $anz; $zaehler > 0; $zaehler--)
    {
      if ($idre == 0 && $re[$zaehler] == $FORM{'id'}) { $idre = $id[$zaehler]; }
      if ($id[$zaehler] < $FORM{'id'} && $re[$zaehler] == $re[$arraynum]) { $idlast = $id[$zaehler]; last; }
      if ($id[$zaehler] > $FORM{'id'} && $re[$zaehler] == $re[$arraynum]) { $idnext = $id[$zaehler]; }
    }
    print '<p align=center>[ ';
    if ($idlast > 0) { print "<a href=\"$0?id=$idlast$sort\">&lt; Vorige lesen</a>"; }
    else { print 'kein Vorg&auml;nger'; }
    print ' | ';
    if ($idre > 0) { print "<a href=\"$0?id=$idre$sort\">Antwort lesen</a>"; }
    else { print 'keine Antwort'; }
    print ' | ';
    if ($idnext > 0) { print "<a href=\"$0?id=$idnext$sort\">N&auml;chste lesen &gt;</a>"; }
    else { print 'kein Nachfolger'; }
    print " ]<br>\n[ <a href=\"$0?$sort\">Zur&uuml;ck</a> | ";
    # Antworten ist nicht mehr moeglich, wenn der Eintrag bereits veraltet ist
    if ($datum[$arraynum] > time - $old_days)
    {
      print "<a href=\"$0?aktion=neu&id=$FORM{'id'}$sort\">Antwort schreiben</a>";
    }
    else
    {
      print 'Antworten nicht m&ouml;glich';
    }
    print " ]</p>\n";
  }
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub neuen_eintrag_holen
{
  print $html_kopf;
  if ($FORM{'id'} > 0)
  {
    &alles_einlesen;
    &suche_arraynum($FORM{'id'});
    $absender[$arraynum] =~ s/%a/&amp;/g; $absender[$arraynum] =~ s/%p/%/g;
    $absender[$arraynum] =~ s/</&lt;/g;
    print "<p><table width=\"$tablewidth\" border=1 cellspacing=0 cellpadding=3><tr><td>\n";
    print $absender[$arraynum] ? $absender[$arraynum] : 'Anonymous';
    if (! $text[$arraynum]) { $text[$arraynum] = $betreff[$arraynum]; }
    # Ueberlange Textteile aus identischen Zeichen auf maximal 10 kuerzen
    $text[$arraynum] =~ s/(.)(\1{10})\1*/$2/g;
    $betreff[$arraynum] =~ s/%a/&amp;/g;
    $betreff[$arraynum] =~ s/%p/%/g; $betreff[$arraynum] =~ s/</&lt;/g;
    $text[$arraynum] =~ s/</&lt;/g; $text[$arraynum] =~ s/>/&gt;/g;
    $text[$arraynum] =~ s/%a/&amp;/g; $text[$arraynum] =~ s/%n/ /g;
    $text[$arraynum] =~ s/%p/%/g;
    if (! $betreff[$arraynum])
    {
      $betreff[$arraynum] = $text[$arraynum];
      $betreff[$arraynum] =~ s/^(.{1,$betreffmax})( |$).*/$1/;
    }
    # Bei sehr langen Texten nur einen gekuerzten Teil als Zitat anzeigen
    if (length($text[$arraynum]) > 1000)
    {
      $text[$arraynum] =~ s/^(.{1,500}) .+? (.{1,500})$/$1<\/i> [...] <i>$2/;
    }
    if ($allow_html)
    {
      # HTML-Formatierungen im Zitat nur sehr eingeschraenkt anzeigen
      $text[$arraynum] =~ s/\[\/?(b|i|img)\]//gi;
      $text[$arraynum] =~ s/\[(tt|pre)\](.+?)\[\/\1\]/<tt>$2<\/tt>/gis;
    }
    print " schrieb: <i>\"$text[$arraynum]\"</i></td></tr></table></p>";
    $betreff[$arraynum] =~ s/"/&quot;/g;
  }

  &getcookie;

  print qq!\n<center><p><table cellspacing=0 cellpadding=0 border=0><tr>
  <form method="post" action="$0" name="formular"><td>
  Betreff<br><input type=text size=$form_width maxlength=$betreffmax name="betreff" value="!;
  if ($betreff[$arraynum] !~ m/^(Re:|$)/i) { print 'Re: '; }
  if ($FORM{'betreff'}) { print $FORM{'betreff'}; }
  print qq!$betreff[$arraynum]"><br>
  Text<br><textarea cols="$form_width" rows="9" name="text" wrap="virtual"></textarea><br>
  Name<br><input type=text size=$form_width maxlength=$absendermax name="absender" value="! . $COOKIE[0] . "\"><br>\n";
  if ($sendmail)
  {
    print "E-Mail (Antworten werden automatisch zugesandt)<br><input type=text size=$form_width maxlength=50 name=\"email\" value=\"";
    print $COOKIE[1] ? $COOKIE[1] : $emaildefault;
    print "\"><br>\n";
  }

  if ($FORM{'id'} > 0)
  {
    print "<input type=hidden name=\"re\" value=\"$FORM{'id'}\">\n";
  }

  print qq!<input type=hidden name="modus" value="$FORM{'modus'}">
  <input type=hidden name="sort" value="$FORM{'sort'}">
  <input type=hidden name="zeilen" value="$FORM{'zeilen'}">
  <input type=submit value="Text eintragen"></td></form></tr></table></center>
  <p align=center>[ <a href="$0?modus=$FORM{'modus'}&sort=$FORM{'sort'}&zeilen=$FORM{'zeilen'}!;
  if ($FORM{'id'} > 0 && $FORM{'modus'} ne "komplett") { print "&id=$FORM{'id'}"; }
  print qq!">Zur&uuml;ck</a> ]</p>\n<script language="JavaScript" type="text/javascript"><\!--\ndocument.formular.!;
  if ($betreff[$arraynum] eq '')
  {
    print 'betreff';
  }
  elsif ($COOKIE[0] eq '')
  {
    print 'absender';
  }
  else
  {
    print 'text';
  }
  print ".focus();\n//--></script>";
  print $html_fuss; die;
}

#-----------------------------------------------------------------------------

sub neuen_eintrag_eintragen
{
  # Eintraege ohne Betreff und ohne Inhalt werden wortlos uebergangen
  if ($FORM{'betreff'} =~ m/^(Re:|.?$)/i && length($FORM{'text'}) < 2) { &zeige_thread; }

  # Eintraege, die groesser als 50 kBytes sind, werden als sinnlos angesehen
  if (length($FORM{'text'}) > 50000)
  {
    print $html_kopf;
    print qq!<p>Eintr&auml;ge dieser Gr&ouml;&szlig;e sind nicht erlaubt.</p>
    <p align=center>[ <a href="$0">Zur&uuml;ck</a> ]</p>!;
    print $html_fuss; die;
  }

  &alles_einlesen;

  # Die Ueberpruefung auf veraltete Threads wird hoechstens einmal am Tag gestartet
  if ($old_days && $datum[1] < time - $old_days && int(time / 86400) > int($datum[$anz] / 86400))
  {
    &old_loeschen;
  }

  # Die naechste freie ID-Nummer wird aus dem letzten Datensatz ermittelt
  $id = $id[$anz] + 1;

  # Echte doppelte Eintraege werden kommentarlos ignoriert
  for ($zaehler = $anz; $zaehler > $anz - 10; $zaehler--)
  {
    if ($betreff[$zaehler] eq "\u$FORM{'betreff'}" && $text[$zaehler] eq $FORM{'text'})
    {
      &zeige_thread;
    }
  }

  # Loescht E-Mails die mit @ beginnen und killt HTML-Tags aus E-Mails
  $FORM{'email'} =~ s/(^@.*|<.*?>)//gs;

  # Jetzt den neuen Eintrag generieren und an die Datendatei anhaengen
  $datensatz = "id=$id&re=$FORM{'re'}&betreff=\u$FORM{'betreff'}&absender=$FORM{'absender'}";
  if ($FORM{'email'}) { $datensatz .= "&email=$FORM{'email'}"; }
  $datensatz .= "&datum=" . time . "&text=$FORM{'text'}&ip=$ENV{'REMOTE_ADDR'}";
  $datensatz .= "\n";
  open(DATEI, ">>$datafile") || die $!;
  flock(DATEI, 2);
  print DATEI $datensatz;
  close(DATEI);

  # Eventuell den Eintrag auch per E-Mail an Empfaenger und Admin schicken
  if ($sendmail && ($FORM{'re'} > 0 || $email_admin))
  {
    $FORM{'text'} =~ s/%a/&/g; $FORM{'text'} =~ s/%p/%/g;
    $FORM{'text'} =~ s/%n/\n/g;
    # Die UBB-Codes nicht in der E-Mail mitschicken
    $FORM{'text'} =~ s/\[\/?(b|i|img|tt|pre)\]//gi;
    $FORM{'betreff'} =~ s/%a/&/g; $FORM{'betreff'} =~ s/%p/%/g;
    $FORM{'absender'} =~ s/%a/&/g; $FORM{'absender'} =~ s/%p/%/g;
    $FORM{'email'} =~ s/%a/&/g;
    # Automatischer Zeilenumbruch innerhalb der E-Mail
    $FORM{'text'} =~ s/(.{1,70})( |\n|$)/$1\n/g;

    if ($email_description)
    {
      $email_description =~ s/id=/id=$id/;
      $email_description .= "\n\n----------------------------------------------------------------------\n\n";
    }

    # E-Mail an den Empfaenger dieser Antwort, falls er das wuenschte.
    &suche_arraynum($FORM{'re'});
    if ($email[$arraynum])
    {
      open(MAIL, "|$sendmail") || die $!;
      print MAIL "From: $FORM{'absender'} <" . ($FORM{'email'} ? $FORM{'email'} : 'do-not-reply@inf.hs-zigr.de') . ">\n";
      print MAIL "To: $absender[$arraynum] <$email[$arraynum]>\n";
      print MAIL "Subject: $email_prefix$FORM{'betreff'}\n\n";
      print MAIL $email_description . $FORM{'text'};
      close(MAIL);
    }

    # E-Mail an den Administrator, aber nur wenn es ein neuer Thread ist.
    if ($email_admin && $FORM{'re'} < 1)
    {
      open(MAIL, "|$sendmail") || die $!;
      print MAIL "From: $FORM{'absender'} <$FORM{'email'}>\n";
      print MAIL "To: Admin <$email_admin>\n";
      print MAIL "Subject: $email_prefix$FORM{'betreff'}\n\n";
      print MAIL $email_description . $FORM{'text'};
      close(MAIL);
    }
  }
  &zeige_thread;
}

#-----------------------------------------------------------------------------

sub old_loeschen
{
  $minimum = time - $old_days;
  # Alle Eintraege anschauen und die Daten der juengsten Antworten merken
  for ($zaehler = 1; $zaehler <= $anz; $zaehler++)
  {
    if (! $re[$zaehler] && $datum[$zaehler] < $minimum)
    {
      $idlistenr++;
      $idliste[$idlistenr]{$id[$zaehler]} = $zaehler;
      $newest[$idlistenr] = $datum[$zaehler];
    }
    elsif ($re[$zaehler])
    {
      for ($i = $idlistenr; $i > 0; $i--)
      {
        if (exists $idliste[$i]{$re[$zaehler]})
        {
          $idliste[$i]{$id[$zaehler]} = $zaehler;
          $newest[$i] = $datum[$zaehler];
          last;
        }
      }
    }
  }

  if ($old_datafile)
  {
    open(DATEI, ">>$old_datafile");
    # Pruefen ob die Sicherungsdatei beschreibbar ist, ansonsten deaktivieren
    if (! -w DATEI) { $old_datafile = ''; }
    else { flock(DATEI, 2); }
  }
  # Threads loeschen, die komplett incl. aller Antworten veraltet sind
  for ($i = 1; $i <= $idlistenr; $i++)
  {
    if ($newest[$i] < $minimum)
    {
      while (($key, $val) = each(%{$idliste[$i]}))
      {
        if ($old_datafile)
        {
          print DATEI "id=$id[$val]&re=$re[$val]&betreff=$betreff[$val]&absender=$absender[$val]&email=$email[$val]&datum=$datum[$val]&text=$text[$val]&ip=$ip[$val]\n";
        }
        undef($id[$val]);
      }
    }
  }
  if ($old_datafile) { close(DATEI); }

  # Datendatei neu schreiben, die alten Eintraege werden dabei weg gelassen
  open(DATEI, ">$datafile") || die $!;
  flock(DATEI, 2);
  for ($i = 1; $i <= $anz; $i++)
  {
    if ($id[$i])
    {
      print DATEI "id=$id[$i]&re=$re[$i]&betreff=$betreff[$i]&absender=$absender[$i]";
      if ($email[$i]) { print DATEI "&email=$email[$i]"; }
      print DATEI "&datum=$datum[$i]&text=$text[$i]&ip=$ip[$i]";
      print DATEI "\n";
    }
  }
  close(DATEI);
}

#-----------------------------------------------------------------------------

sub initialisieren
{
  # Eingabedaten splitten und ins Array $FORM{'...'} schreiben
  if ($ENV{'REQUEST_METHOD'} eq 'GET')
  {
    $buffer = $ENV{'QUERY_STRING'};
  }
  else
  {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
  } 
  @pairs = split(/&/, $buffer);
  foreach $pair (@pairs)
  {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    # Hexadezimal kodierte Zeichen werden aufgeloest
    $value =~ s/%(\w{2})/pack('C',hex($1))/eg;
    # Leerer Quatsch am Anfang und Ende wird geloescht
    $value =~ s/^\s+//; $value =~ s/\s+$//;
    # Durchgaengige Codierung von Prozent=%p, Newline=%n und Ampersand=%a
    $value =~ s/%/%p/g; $value =~ s/\r*\n/%n/g; $value =~ s/&/%a/g;
    $FORM{$name} = $value;
  }

  # Existenz der Datendatei pruefen und evtl. neu erzeugen
  if (! (-f $datafile))
  {
    open(DATEI, ">$datafile") || die $!;
    print DATEI '';
    close(DATEI);
  }
  $0 =~ s/.*\///; # Den Dateinamen des Scriptes selbst freistellen
}

#-----------------------------------------------------------------------------

sub alles_einlesen
{
  open(DATEI, "<$datafile") || die $!;
  $anz = 0;
  # Datei zeilenweise einlesen, die Zeile wird in $_ zwischengespeichert
  while (<DATEI>)
  {
    $anz++; chop;
    # Die Zeile an jedem '&' aufsplitten, Speicherung des Teiles in $pair
    foreach $pair (split(/&/))
    {
      # Zerteilen in ein Paar aus Variablenname und Wert
      ($name, $value) = split(/=/, $pair, 2);
      # Uebernahme dieses Wertes in ein normales Array, linear nummeriert
      $$name[$anz] = $value;
    }
  }
  close(DATEI);
}

#-----------------------------------------------------------------------------

sub suche_arraynum
{
  # In $_[0] kommt die zu suchende ID, in $_[1] ein Startwert fuer $arraynum,
  # von dort aus wird rueckwaerts gesucht
  $arraynum = $_[1] ? $_[1] : $anz;
  while ($id[$arraynum] != $_[0])
  {
    if (--$arraynum < 1) { return -1; last; }
  }
}

#-----------------------------------------------------------------------------

sub datum
{
  ($sec, $min, $hour, $day, $mon, $year) = localtime($_[0]);
  $year += 1900;
  if ($hour < 10) { $hour = "0$hour"; }
  if ($min < 10) { $min = "0$min"; }
  if ($_[1])
  {
    @monat = ('Januar', 'Februar', 'M&auml;rz', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember');
    return "$day. $monat[$mon] $year, $hour:$min Uhr";
  }
  else
  {
    if ($aday == int(($_[0]/3600+1)/24)) { return "heute, $hour:$min"; }
    elsif ($aday - 1 == int(($_[0]/3600+1)/24)) { return "gestern, $hour:$min"; }
    else
    {
      if ($day < 10) { $day = "0$day"; }
      if (++$mon < 10) { $mon = "0$mon"; }
      return "$day.$mon.$year,&nbsp;$hour:$min";
    }
  }
}

#-----------------------------------------------------------------------------

sub parse_html
{
  $_[0] =~ s!%n!\n!g;
  $_[0] =~ s!%a!&!g;
  # Nur diejenigen Prozentzeichen maskieren, die Teil eines HTML-Codes sind
  $_[0] =~ s!&(?=[#\w]+;)!&amp;!g;
  # Alle eventuell vorhandenen HTML-Codes maskieren
  $_[0] =~ s!<!&lt;!g; $_[0] =~ s!>!&gt;!g;
  $_[0] =~ s!%p!%!g;
  # Links muessen mit http:// oder www. beginnen, alle Parameter sind erlaubt
  $_[0] =~ s!(^|[^\]/])(http://|(www\.))(\w[\w%\.\-~/#?=&+,;]+[\w/])!$1<a href="http://$3$4" target="_blank">$2$4</a>!gi;
  # Links zu Datendateien werden nicht in einem neuen Fenster geoeffnet
  $_[0] =~ s!\.(zip|rar|exe|mp3|tgz|gz|doc)" target="_blank">!\.$1">!gi;
  # Mailadressen muessen ein @ und am Ende mindestens einen Punkt enthalten
  $_[0] =~ s!(\w[\w\.\-]*\w@\w[\w\.\-]+\.\w+)!<a href="mailto:$1">$1</a>!g;
  if ($allow_html)
  {
    # Adresssen von Bildern muessen unbedingt mit http:// beginnen
    $_[0] =~ s!\[img\](http://[\w\.\-~/]+\.(gif|jpg|jpeg|png))\[/img\]!<img src="$1" alt="$1">!gi;
    $_[0] =~ s!\[(b|i|tt)\](.+?)\[/\1\]!<$1>$2</$1>!gis;
    #$_[0] =~ s!\[pre\]\n*(.+?)\s*\[/pre\]!$_=$1;s/<br>//g;"<pre>$_</pre>"!egis;
    # Zeilenumbrueche werden nur ausserhalb von pre in br umgewandelt
    $_[0] =~ s!(\s*\[pre\]\n*(.*?)\s*\[/pre\]\s*|\n)!$2 ? "<pre>$2</pre>" : "<br>\n"!egis;
  }
  else
  {
    $_[0] =~ s!\n!<br>\n!g;
  }
}

#-----------------------------------------------------------------------------

sub getcookie
{
  @cookies = split(/; /, $ENV{'HTTP_COOKIE'});
  foreach $cookieraw (@cookies)
  {
    ($cookiename, $cookieval) = split(/=/, $cookieraw);
    if ($cookiename eq 'ii99')
    {
      $cookieval =~ tr/+/ /;
      $cookieval =~ s/%(\w{2})/pack('C',hex($1))/eg;
      @COOKIE = split(/\t/, $cookieval);
      break;
    }
  }
}
