#-----------------------------------------------------------------------------
# Konfigurations-Datei des II99-Forums von Thiemo Mttig, thiemo@maettig.com
# Zuletzt ueberarbeitet am 2003-03-07
#-----------------------------------------------------------------------------

# Der vollstaendige Pfad zur Textdatei, in der die Eintraege abgelegt werden.
$datafile = '/home/group/user/public_html/cgi-bin/ii99forum.txt';

# Wie alt duerfen Eintraege maximal sein, damit sie als neu markiert werden?
# Das Alter muss in Sekunden angegeben werden. 3600 Sekunden sind 1 Stunde.
$new_hours = 48 * 3600;
$new_text = ' <small class="new">&nbsp;neu&nbsp;</small>';

# Eintraege, die aelter als x Tage sind, werden entweder geloescht (dazu die
# zweite Variable einfach leer lassen) oder in die Sicherungsdatei verschoben.
# Das Alter muss in Sekunden angegeben werden. 86400 Sekunden sind 1 Tag.
$old_days = 360 * 86400;
$old_datafile = '';

#-----------------------------------------------------------------------------

# Vorbelegung des E-Mail Feldes fuer den Absender. Sollte mit @ beginnen oder
# ganz leer gelassen werden.
$emaildefault = '@inf.hs-zigr.de';

# Neu gestartete Topics automatisch als Kopie an den Administrator des Forums
# verschicken. Variable leer lassen, wenn das nicht gewuenscht wird.
$email_admin = '';

# Texte, die per E-Mail verschickt werden, erhalten zusaetzlich vor dem
# Betreff ein Praefix und vor dem Text die erklaerende Beschreibung. Die
# fehlende ID wird automatisch eingesetzt.
$email_prefix = '[II99] ';
$email_description = 'Im II99-Forum wurde der folgende Text fr dich hinterlegt.
Um darauf zu antworten, klicke bitte hier:
http://www.example.com/~user/cgi-bin/ii99forum.cgi?id=';

#-----------------------------------------------------------------------------

# Hintergrundfarbe der verschiedenfarbig unterlegten Bildschirmelemente.
$bgfarbe = '#e1e1e1';

# Wieviele Zeilen sollen standardmaessig auf einem Bildschirm erscheinen?
# Sinnvolle, vordefinierte Werte sind 25 oder 50.
$zeilen = 50;

# Breite der Tabellen entweder in Prozent (z.B. 100%) oder absolut (z.B. 670).
$tablewidth = '100%';

# Die Breite aller Formularzellen. Bewaehrt hat sich der Wert 56.
$form_width = 56;

# Maximal moegliche Laenge des Betreff- und des Absender-Feldes.
$betreffmax = 60;
$absendermax = 25;

#-----------------------------------------------------------------------------

# Bilder und grundlegende HTML-Tags sind erlaubt. Anzeige nur in der
# Detailansicht und auch nur im Text. Kodierung mit [b]fett[/b], [i]kursiv[/i],
# [tt]teletyp[/tt], [img]http://www.example.com/bild.gif[/img]
$allow_html = 1;

# Die alternativen Sortiermodi wie z.B. "Komplett" koennen deaktiviert werden.
$allow_modes = 1;

#-----------------------------------------------------------------------------

# Das Programm zum Senden von E-Mails. Wenn diese Funktion nicht gewuenscht
# wird, kann die Variable leer gelassen werden.
$sendmail = '/usr/sbin/sendmail -t';

#-----------------------------------------------------------------------------

# Der Kopf und der Fuss wird immer ausgegeben. Der Befehl qq!Text! bewirkt,
# dass im Text zwischen den Ausrufezeichen alle Sonderzeichen erlaubt sind.
# Nur Ausrufezeichen und At's muessen als \! und \@ geschrieben werden.

$html_kopf = qq!Content-Type: text/html\n
<html>
<head>
<title>II99-Forum</title>
<meta name="robots" content="noindex,nofollow">
<meta http-equiv="expires" content="0">
<meta http-equiv="pragma" content="no-cache">
<style type="text/css">
<\!--
h1{color:#330066;background-color:#ccccff;}
p,th,td{font-family:sans-serif;font-size:11pt;}
.new{font-size:10px;color:#ffffff;background-color:#cc6699;}
//-->
</style>
</head>
<body bgcolor="#FFFFFF">

<h1 align="center">II99-Forum</h1>
!;

#-----------------------------------------------------------------------------

$html_fuss = qq!
</body>
</html>
!;

#-----------------------------------------------------------------------------

# Diese Textteile werden vor und hinter der grossen Listenanzeige ausgegeben.
# Ich bitte darum, den Copyright-Vermerk NICHT zu entfernen. Das II99-Forum
# darf fuer nicht-kommerzielle Zwecke frei verwendet werden. Der
# Copyrightvermerk ist die einzige Gegenleistung, die ich von euch erwarte.
# Vielen Dank.
# Thiemo

$html_begruessung = qq!
<p align="center">
Willkommen im II99-Forum\!
</p>
!;

$html_schlusswort = qq!
<p align="center">
<small>(c) <a href="ii99forum_doku.html">II99-Forum</a> von
<a href="http://www.maettig.com/">Thiemo Mttig</a></small>
</p>
!;
